#
# WEB PATIO : session.pl - 2011/08/15
# Copyright (c) KentWeb
# http://www.kent-web.com/
#

# W[荞
use strict;
use CGI::Session;

#-----------------------------------------------------------
#  ZbV쐬
#-----------------------------------------------------------
sub make_ses {
	my ($uid,$upw,$file,$dir,$autime) = @_;

	# 
	my %au;

	# t@CI[v
	my $flg;
	open(IN,"$file") or &error("open err: $file");
	while (<IN>) {
		my ($id,$pw,$rank,$nam) = split(/<>/);

		if ($uid eq $id) {
			$flg = 1;

			# ƍ
			if (&decrypt($upw,$pw) == 1) {
				$flg = 2;
				#$data = "$rank\t$nam";
				$au{name} = $nam;
				$au{rank} = $rank;
			}
			last;
		}
	}
	close(IN);

	# ƍs
	&error("F؂ł܂") if ($flg != 2);

	# VKZbVs
	my $ses = new CGI::Session(undef,undef,{Directory => $dir}) or die CGI::Session->errstr;

	# f[^i[
	$ses->param(-name => 'id',   -value => $uid);
	$ses->param(-name => 'name', -value => $au{name});
	$ses->param(-name => 'rank', -value => $au{rank});

	# L
	my $jobtime = $autime * 60;
	$ses->expire($jobtime);

	# ZbVID
	$au{sid} = $ses->id();

	# OCID
	$au{id} = $uid;

	# Ԃl
	return %au;
}

#-----------------------------------------------------------
#  OAEg
#-----------------------------------------------------------
sub del_ses {
	my $dir = shift;

	# ZbVF
	my $ses = CGI::Session->load(undef,undef,{Directory => $dir}) or die;
	$ses->delete();
}

#-----------------------------------------------------------
#  ZbVmF
#-----------------------------------------------------------
sub session {
	my ($dir,$bbs) = @_;

	# ZbVF
	my $ses = CGI::Session->load(undef,undef,{Directory => $dir}) or die;

	# ZbVȂ
	if ($ses->is_empty) {
		&enter_form;
	}

	# ؂
	if ($ses->is_expired) {
		my $msg = qq|^CAEgłBēxOCĂB\n|;
		$msg .= qq|<p>[<a href="$bbs?mode=enter">OC</a>]</p>\n|;
		&error($msg);
   	}

	# f[^
	my %au;
	$au{id}   = $ses->param('id');
	$au{name} = $ses->param('name');
	$au{rank} = $ses->param('rank');

	# Ԃl
	return %au;
}



1;

